<template>
  <div>
    <BasicTable @register="registerTable">
      <template #toolbar>
        <a-button type="primary" @click="handleCreate"> 新增</a-button>
      </template>
      <template #bodyCell="{ column, record }">
        <template v-if="column.dataIndex === 'action'">
          <TableAction
            :actions="[
              {
                label: '编辑',
                icon: 'clarity:note-edit-line',
                onClick: handleEdit.bind(null, record),
                divider: true
              },
              {
                label: '详情',
                icon: 'ant-design:eye-outlined',
                onClick: handleView.bind(null, record),
                divider: true
              },
            ]"
            :dropDownActions="[
              {
                label: '删除',
                icon: 'ant-design:delete-outlined',
                color: 'error',
                popConfirm: {
                  title: '是否确认删除',
                  confirm: handleDelete.bind(null, record),
                  placement: 'topRight',
                },
              },
            ]"
          />
        </template>
      </template>
    </BasicTable>
    <ConstantDrawer @register="registerDrawer" @success="handleSuccess" />
  </div>
</template>
<script lang="ts" setup>
  import { ref } from 'vue';
  import { Alert,Popconfirm } from 'ant-design-vue';
  import { useGo } from '@/hooks/web/usePage';
  import { usePermission } from '@/hooks/web/usePermission';
  import { BasicTable, useTable, TableAction } from '@/components/Table';
  import { isObject } from '@/utils/is';
  import dayjs from 'dayjs';
  import * as ConstantApi from '@/api/system/constantApi';
  import { useDrawer } from '@/components/Drawer';
  import ConstantDrawer from './drawer.vue';
  import { columns, searchFormSchema } from './schema';
  import { useMessage } from "@/hooks/web/useMessage";

  defineOptions({
    name: 'AUTH_SYSTEM_CONSTANT'
  })

  const { createMessage } = useMessage();
  const { hasPermission } = usePermission();
  const go = useGo();

  const [registerDrawer, { openDrawer }] = useDrawer();
  const [registerTable, { reload, setSelectedRowKeys }] = useTable({
    title: '常量表',
    api: (params) => ConstantApi.search(handleParams(params)),
    columns,
    formConfig: {
      labelWidth: 120,
      schemas: searchFormSchema,
      showAdvancedButton: false,
    },
    useSearchForm: true,
    showTableSetting: false,
    bordered: false,
    showIndexColumn: false,
    canResize: false,
    rowKey: (record: any) => record.id,
    actionColumn: {
      width: 170,
      title: '操作',
      dataIndex: 'action',
      fixed: 'right',
    },
  });

  const handleParams = (params) => {
    const { pageNum, pageSize, field = 'id', order = 'descend', ...rest } = params;
    const handledParams: any = { pageNum, pageSize, orderByClause: `${field} ${order === 'descend' ? 'desc' : 'asc'}` };
    Object.keys(rest).forEach((key) => {
      const schema = searchFormSchema.find((item) => item.field === key);
      const value = params[key];
      const paramKey = key;
      if (schema) {
        if (value !== undefined && value !== '') {
          if (schema.component === 'Input') {
            handledParams[paramKey] = `%${value.trim()}%`;
          } else if (['Select', 'ApiSelect', 'ApiTreeSelect'].includes(schema.component)) {
            handledParams[paramKey] = isObject(value) ? value.value : value;
          } else if (schema.component === 'RangePicker') {
            handledParams[`${paramKey}From`] = dayjs(value[0]).startOf('d').format('YYYY-MM-DD HH:mm:ss');
            handledParams[`${paramKey}To`] = dayjs(value[1]).endOf('d').format('YYYY-MM-DD HH:mm:ss');
          } else if (schema.component === 'DatePicker') {
            handledParams[paramKey] = dayjs(value).format((schema.componentProps as any).format || 'YYYY-MM-DD');
          } else {
            handledParams[paramKey] = value;
          }
        }
      } else {
        handledParams[paramKey] = value;
      }
    });
    return handledParams;
  };

  const handleCreate = () => {
    openDrawer(true, {
      isUpdate: false,
    });
  };

  const handleEdit = (record: Recordable) => {
    openDrawer(true, {
      record,
      isUpdate: true,
    });
  };

  const handleDelete = (record: Recordable) => {
    ConstantApi.remove(record.id).then((_) => {
      reload();
    });
  };

  const handleSuccess = () => {
    reload();
  };

  const handleView = (record) => {
    go('/system/constant/detail/' + record.id);
  };
</script>
<style lang="scss" scoped>
  @use '@/assets/custom.scss';
</style>
